package cz.mendelu.dnaAnalyser.analyse.palindrome;

import cz.mendelu.dnaAnalyser.analyse.palindrome.model.StabilityModel;
import cz.mendelu.dnaAnalyser.sequence.Sequence;
import cz.mendelu.dnaAnalyser.user.User;
import cz.mendelu.dnaAnalyser.utils.analyse.model.Analyse;
import cz.mendelu.dnaAnalyser.utils.model.Identifiable;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import javax.persistence.Entity;
import javax.persistence.Transient;
import java.util.Date;
import java.util.Set;
import java.util.UUID;

@Data
@Entity
@ToString(callSuper = true)
@EqualsAndHashCode(callSuper = true)
public class PalindromeAnalyse extends Analyse implements Identifiable {

    /*
    public PalindromeModel() {
        super(PalindromeModel.class.getPackage().getName());
    }
    */

    private String mismatches;
    @Transient
    private int size;
    @Transient
    private int mismatche;
    @Transient
    private int spacer;
    @Transient
    private String spacers;
    @Transient
    private int position;
    @Transient
    private StabilityModel stabilityModel;

    public PalindromeAnalyse() {
    }

    @Builder
    private PalindromeAnalyse(UUID id, Date created, Sequence sequence, User owner, Set<String> tags, Date finished, String title, Long resultCount, Integer size, String spacers, Integer spacer, String mismatches, Integer mismatche, int position) {
        super((id != null) ? id : UUID.randomUUID(), created, sequence, owner, tags, finished, title, resultCount);
        this.size = size;
        this.spacers = spacers;
        this.spacer = spacer;
        this.mismatches = mismatches;
        this.mismatche = mismatche;
        this.position = position;
    }

    /*
    public NumberRange sizeAsNumberRange() {
        return (size == null) ? null : new NumberRange(size);
    }

    public NumberRange spacerAsNumberRange() {
        return (spacer == null) ? null : new NumberRange(spacer);
    }

    public NumberRange mismatchesAsNumberRange() {
        return (mismatches == null) ? null : new NumberRange(mismatches);
    }
    */
}
