package cz.mendelu.dnaAnalyser.sequence;

import cz.mendelu.dnaAnalyser.utils.repository.BaseRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;
import java.util.UUID;

@Repository
public interface SequenceRepository extends BaseRepository<Sequence, UUID> {

    List<Sequence> findAllByOwnerIsNull();

    @Query("SELECT ncbi FROM Sequence WHERE id=:id")
    String getNcbi(@Param("id") UUID id);

    @Query("SELECT name FROM Sequence WHERE id=:id")
    String getName(@Param("id") UUID id);

    @Query("select s from Sequence as s join s.owner o where o.id = ?#{principal.id}")
    Page<Sequence> findAll(Pageable pageable);

    @Query("select s from Sequence as s join s.owner o join s.tags t where t = :tag and o.id = ?#{principal.id}")
    Page<Sequence> findAll(Pageable pageable, @Param("tag") String tag);

    @Query("select s from Sequence as s join s.owner o where s.id = :id and o.id = ?#{principal.id}")
    Optional<Sequence> findById(@Param("id") UUID id);

    @Query("select distinct t from Sequence as s join s.owner o join s.tags t where o.id = ?#{principal.id}")
    Page<String> findAllTags(Pageable pageable);

    List<Sequence> findByNcbi(String ncbi);
}
