package cz.mendelu.dnaAnalyser.utils.analyse;

import cz.mendelu.dnaAnalyser.utils.FirstRunImporter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.context.event.ApplicationReadyEvent;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.event.EventListener;
import org.springframework.core.io.Resource;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.core.io.support.ResourcePatternResolver;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Arrays;

@Slf4j
@Configuration
public class AnalyseImporter {

    @Autowired
    private FirstRunImporter importer;

    @Value("${analyse.dir}")
    private String destDir;

    @EventListener(ApplicationReadyEvent.class)
    public void copyDefaultAnalyseToWorkingDirectory() {
        try {
            importer.importFiles("db/data/analyses/", destDir);
        } catch (Exception e) {
            log.warn("Create default analyses failed.", e);
        }

    }
}
