package cz.mendelu.dnaAnalyser.utils.analyse.repository;

import cz.mendelu.dnaAnalyser.utils.analyse.model.Analyse;
import cz.mendelu.dnaAnalyser.utils.repository.BaseRepository;
import cz.mendelu.dnaAnalyser.sequence.Sequence;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.UUID;

@Repository
public interface AnalyseRepository extends BaseRepository<Analyse, UUID> {

    @Query("SELECT sequence FROM Analyse as a WHERE a.id= :id")
    Sequence getSequence(@Param("id") UUID id);

    @Query("select a from Analyse as a join a.owner o where o.id = ?#{principal.id}")
    Page<Analyse> findAll(Pageable pageable);

    @Query("select a from Analyse as a join a.owner o join a.tags t where t = :tag and o.id = ?#{principal.id}")
    Page<Analyse> findAll(Pageable pageable, @Param("tag") String tag);

    @Query("select a from Analyse as a where a.id = :id")  //join a.owner o where a.id = :id and o.id = ?#{principal.id}")
    Analyse findOne(@Param("id") UUID id);

    @Query("select t from Analyse as s join s.owner o join s.tags t where o.id = ?#{principal.id}")
    Page<String> findAllTags(Pageable pageable);
}
