package cz.mendelu.dnaAnalyser.utils.service;

import com.fasterxml.jackson.databind.ObjectMapper;
import cz.mendelu.dnaAnalyser.utils.exception.InternalServerException;
import org.springframework.stereotype.Service;

import java.io.IOException;

@Service
public class JsonService {

    private final ObjectMapper mapper = new ObjectMapper();

    public <T> T fromJson(String json, Class<T> tClass) {
        try {
            return mapper.readValue(json, tClass);
        } catch (IOException e) {
            throw new InternalServerException("Map object from json failed.", e);
        }
    }
}
